/*
TECNISA - TECNOLOGIA EM INFORMTICA

NOME: UPDATE_ITEM_VENDA

DESCRIO:
   Procedimento para agrupar produtos iguais, no mesmo intervalo de data em uma s nota fiscal.

CRIAO:
   16/12/2005 - wander alex

@C:\Web_406\Sql\End_Conv\Oracle\5502_DFSSTPO_UPDATE_ITEM_VENDA.SQL
RAISE_APPLICATION_ERROR(-20501,, TRUE);
*/

CREATE OR REPLACE PROCEDURE UPDATE_ITEM_VENDA
   (P_CDFILIAL   IN FILIAL.CDFILIAL%TYPE,
    P_CDLOJA     IN VENDA.CDLOJA%TYPE,
    P_DTINICIAL  IN NOTAFISCAL.DTENTRSAID%TYPE,
    P_DTFINAL    IN NOTAFISCAL.DTENTRSAID%TYPE,
    P_CDCAIXA    IN VARCHAR2,
    P_LISTAVENDA IN VARCHAR2,
    P_CDPRODUTO  IN VARCHAR2,
    P_CDFILIPROC IN NOTAFISCAL.CDFILIAL%TYPE,
    P_DSMENSAGEM IN VARCHAR2,
    P_NRLANCTONF IN NOTAFISCAL.NRLANCTONF%TYPE,
    P_CDCONTADOR IN NUMBER)

AS

   V_DSDADOADIC     DADOSADIC.DSDADOADIC%TYPE;
   V_NRDADOADIC     DADOSADIC.NRDADOADIC%TYPE;
   V_IDTIPORECE     TIPORECE.IDTIPORECE%TYPE;
   V_NRCUPOMFIS     VENDA.NRCUPOMFIS%TYPE;
   V_DSMENSCPFCUP   CAIXA.DSMENSCPFCUP%TYPE;
   V_DSMENSDADOADIC DADOSADIC.DSDADOADIC%TYPE;
   V_DSMD5FORSALE   PARAVEND.DSMD5FORSALE%TYPE;
   V_NRDADOADICAUX  DADOSADIC.NRDADOADIC%TYPE;

   CURSOR C_ITEMVENDA IS
      SELECT DISTINCT V.CDFILIAL, V.NRSEQVENDA, V.CDCAIXA, V.CDLOJA,
             I.CDFILIALNF, V.DTENTRVENDA, I.CDPRODUTO, V.NRCUPOMFIS,
             (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)) AS VRUNITVEND,
             V.DSMARCAECFVE, V.DSMODELOECFVE, V.NRSERIEIMPVND
      FROM VENDA V, ITEMVENDA I
      WHERE (V.CDFILIAL     = P_CDFILIAL)       AND
            (V.CDLOJA       = P_CDLOJA)         AND
            (V.CDFILIAL     = I.CDFILIAL)       AND
            (V.CDCAIXA      = I.CDCAIXA)        AND
            (V.NRSEQVENDA   = I.NRSEQVENDA)     AND
            (V.IDSITUVENDA  = 'O')              AND
            (I.NRLANCTONF   IS NULL)            AND
            (V.DTENTRVENDA BETWEEN P_DTINICIAL  AND P_DTFINAL) AND
            ((INSTR(P_CDCAIXA, V.CDCAIXA) > 0)  OR (P_CDCAIXA IS NULL)) AND
            ((P_LISTAVENDA IS NULL) OR (INSTR(P_LISTAVENDA, V.CDFILIAL||V.CDCAIXA||V.NRSEQVENDA) > 0)) AND
            ((INSTR(P_CDPRODUTO, I.CDPRODUTO) > 0) OR (P_CDPRODUTO IS NULL));

   CURSOR C_ITEMDEVOLUCAO IS
      SELECT DISTINCT V.CDFILIAL, V.NRSEQVENDA, V.CDCAIXA, V.CDLOJA, I.CDFILIALNF,
             V.DTENTRVENDA, I.CDPRODUTO, V.NRCUPOMFIS,
             (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)) AS VRUNITVEND,
             V.DSMARCAECFVE, V.DSMODELOECFVE, V.NRSERIEIMPVND
      FROM VENDA V, ITEMVENDA I
      WHERE (V.CDFILIAL     = P_CDFILIAL)       AND
            (V.CDLOJA       = P_CDLOJA)         AND
            (V.CDFILIAL     = I.CDFILIAL)       AND
            (V.CDCAIXA      = I.CDCAIXA)        AND
            (V.NRSEQVENDA   = I.NRSEQVENDA)     AND
            (V.IDSITUVENDA  = 'D')              AND
            (I.NRLANCTONF   IS NULL)            AND
            (V.DTENTRVENDA BETWEEN P_DTINICIAL  AND P_DTFINAL) AND
            ((INSTR(P_CDCAIXA, V.CDCAIXA) > 0)  OR (P_CDCAIXA IS NULL)) AND
            ((P_LISTAVENDA IS NULL) OR (INSTR(P_LISTAVENDA, V.CDFILIAL||V.CDCAIXA||V.NRSEQVENDA) > 0)) AND
            ((INSTR(P_CDPRODUTO, I.CDPRODUTO) > 0) OR (P_CDPRODUTO IS NULL));

BEGIN

   V_DSDADOADIC := '';
   V_NRCUPOMFIS := 'X';

   /*Atualizao de Cdigo MD5 na Tabela de Dados Adicionais*/
   SELECT NVL(MAX(NRDADOADIC), '0')
     INTO V_NRDADOADIC
     FROM DADOSADIC
    WHERE CDFILIAL   = P_CDFILIPROC
      AND NRLANCTONF = P_NRLANCTONF;

   V_NRDADOADIC := LPAD(TO_CHAR(TO_NUMBER(NVL(V_NRDADOADIC, '0')) + 1),3,'0');

   SELECT DSMD5FORSALE
     INTO V_DSMD5FORSALE
     FROM PARAVEND
    WHERE CDFILIAL = P_CDFILIPROC;

   IF (V_DSMD5FORSALE IS NOT NULL) THEN
      SELECT MAX(NRDADOADIC)
        INTO V_NRDADOADICAUX
        FROM DADOSADIC
       WHERE CDFILIAL   = P_CDFILIPROC
         AND NRLANCTONF = P_NRLANCTONF
         AND INSTR(DSDADOADIC, 'Cdigo MD5') > 1;

      IF (V_NRDADOADICAUX IS NULL) THEN
         INSERT INTO DADOSADIC
         (CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
         VALUES
         (P_CDFILIPROC, P_NRLANCTONF, V_NRDADOADIC, 'Cdigo MD5: ' || V_DSMD5FORSALE);
      END IF;
   END IF;

   /*Atualizao de Nmeros de Cupons na Tabela de Dados Adicionais*/
   SELECT NVL(MAX(NRDADOADIC), '0')
     INTO V_NRDADOADIC
     FROM DADOSADIC
    WHERE CDFILIAL   = P_CDFILIPROC
      AND NRLANCTONF = P_NRLANCTONF;

   FOR C_GERANF IN C_ITEMVENDA LOOP

      /*Atualizao da Tabela ITEMVENDA*/
      UPDATE ITEMVENDA
      SET CDFILIALNF  = P_CDFILIPROC,
          NRLANCTONF  = P_NRLANCTONF,
          NRSEQITPROD = LPAD(TO_CHAR(P_CDCONTADOR),4,'0')
      WHERE (CDFILIAL     = C_GERANF.CDFILIAL)   AND
            (CDCAIXA      = C_GERANF.CDCAIXA)    AND
            (NRSEQVENDA   = C_GERANF.NRSEQVENDA) AND
            (CDPRODUTO    = C_GERANF.CDPRODUTO)  AND
            ((VRUNITVEND + NVL(VRUNITVENDCL,0)) = C_GERANF.VRUNITVEND);

      /*Atualizao de Nmeros de Cupons na Tabela de Dados Adicionais*/
      SELECT NVL(MAX(NRDADOADIC), '0')
        INTO V_NRDADOADICAUX
        FROM DADOSADIC
       WHERE CDFILIAL   = P_CDFILIPROC
         AND NRLANCTONF = P_NRLANCTONF
         AND INSTR(DSDADOADIC, 'Marca:') > 1;

      SELECT MAX(DSDADOADIC)
        INTO V_DSDADOADIC
        FROM DADOSADIC
       WHERE CDFILIAL   = P_CDFILIPROC
         AND NRLANCTONF = P_NRLANCTONF
         AND NRDADOADIC = V_NRDADOADICAUX;

      IF TO_NUMBER(V_NRDADOADICAUX) > 0 THEN
         V_NRDADOADIC := V_NRDADOADICAUX;
      END IF;

      SELECT MAX(T.IDTIPORECE)
      INTO V_IDTIPORECE
      FROM MOVICLIE M, TIPORECE T
      WHERE M.CDFILIAL   = C_GERANF.CDFILIAL   AND
            M.CDCAIXA    = C_GERANF.CDCAIXA    AND
            M.NRSEQVENDA = C_GERANF.NRSEQVENDA AND
            M.CDTIPORECE = T.CDTIPORECE        AND
            T.IDTIPORECE <> '9';

      IF V_NRDADOADIC < '998' THEN

         IF V_NRCUPOMFIS <> C_GERANF.NRCUPOMFIS THEN
            IF ((LENGTH(V_DSDADOADIC || ', ' || C_GERANF.NRCUPOMFIS) >= 120) OR (V_DSDADOADIC IS NULL)) AND (C_GERANF.NRCUPOMFIS IS NOT NULL) THEN

--               IF V_IDTIPORECE IS NULL THEN
                  V_DSDADOADIC := P_DSMENSAGEM || C_GERANF.NRCUPOMFIS ||
                                  ' (Marca: ' || SUBSTR(C_GERANF.DSMARCAECFVE, 1, 15) ||
                                  ', Mod: ' || SUBSTR(C_GERANF.DSMODELOECFVE, 1, 15) ||
                                  ', N: ' || C_GERANF.NRSERIEIMPVND ||
                                  ')';

                  V_NRDADOADIC := LPAD(TO_CHAR(TO_NUMBER(NVL(V_NRDADOADIC, '0')) + 1),3,'0');

                  INSERT INTO DADOSADIC
                     (CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                  VALUES
                     (P_CDFILIPROC, P_NRLANCTONF, V_NRDADOADIC, V_DSDADOADIC);

--               END IF;
            ELSE
--               IF V_IDTIPORECE IS NULL THEN
                  V_DSDADOADIC := V_DSDADOADIC || ', ' || C_GERANF.NRCUPOMFIS ;

                  UPDATE DADOSADIC
                  SET DSDADOADIC = V_DSDADOADIC
                  WHERE CDFILIAL   = P_CDFILIPROC AND
                        NRLANCTONF = P_NRLANCTONF AND
                        NRDADOADIC = V_NRDADOADIC;
--               END IF;
            END IF;

            V_NRCUPOMFIS := NVL(C_GERANF.NRCUPOMFIS, 'X');

         END IF;
      END IF;
   END LOOP;

   V_DSDADOADIC := '';
   V_NRCUPOMFIS := 'X';

   SELECT NVL(MAX(NRDADOADIC), '0')
      INTO V_NRDADOADIC
      FROM DADOSADIC
      WHERE CDFILIAL   = P_CDFILIPROC AND
            NRLANCTONF = P_NRLANCTONF;

   FOR C_GERANFDEV IN C_ITEMDEVOLUCAO LOOP

      /*Atualizao da Tabela ITEMVENDA*/
      UPDATE ITEMVENDA
      SET CDFILIALNF  = P_CDFILIPROC,
          NRLANCTONF  = P_NRLANCTONF,
          NRSEQITPROD = LPAD(TO_CHAR(P_CDCONTADOR),4,'0')
      WHERE (CDFILIAL     = C_GERANFDEV.CDFILIAL)   AND
            (CDCAIXA      = C_GERANFDEV.CDCAIXA)    AND
            (NRSEQVENDA   = C_GERANFDEV.NRSEQVENDA) AND
            (CDPRODUTO    = C_GERANFDEV.CDPRODUTO)  AND
            ((VRUNITVEND + NVL(VRUNITVENDCL,0)) = C_GERANFDEV.VRUNITVEND);

      /*Atualizao de Nmeros de Cupons na Tabela de Dados Adicionais*/
      SELECT NVL(MAX(NRDADOADIC), '0')
        INTO V_NRDADOADICAUX
        FROM DADOSADIC
       WHERE CDFILIAL   = P_CDFILIPROC
         AND NRLANCTONF = P_NRLANCTONF
         AND INSTR(DSDADOADIC, 'Marca:') > 0;

      SELECT MAX(DSDADOADIC)
        INTO V_DSDADOADIC
        FROM DADOSADIC
       WHERE CDFILIAL   = P_CDFILIPROC
         AND NRLANCTONF = P_NRLANCTONF
         AND NRDADOADIC = V_NRDADOADICAUX;

      IF TO_NUMBER(V_NRDADOADICAUX) > 0 THEN
         V_NRDADOADIC := V_NRDADOADICAUX;
      END IF;

      SELECT MAX(T.IDTIPORECE)
      INTO V_IDTIPORECE
      FROM MOVICLIE M, TIPORECE T
      WHERE M.CDFILIAL   = C_GERANFDEV.CDFILIAL   AND
            M.CDCAIXA    = C_GERANFDEV.CDCAIXA    AND
            M.NRSEQVENDA = C_GERANFDEV.NRSEQVENDA AND
            M.CDTIPORECE = T.CDTIPORECE        AND
            T.IDTIPORECE <> '9';

      IF V_NRDADOADIC < '998' THEN
         IF V_NRCUPOMFIS <> C_GERANFDEV.NRCUPOMFIS THEN
            IF ((LENGTH(V_DSDADOADIC || ', '|| C_GERANFDEV.NRCUPOMFIS) >= 120) OR (V_DSDADOADIC IS NULL)) AND (C_GERANFDEV.NRCUPOMFIS IS NOT NULL) THEN
--               IF V_IDTIPORECE IS NULL THEN
                  V_DSDADOADIC := P_DSMENSAGEM || C_GERANFDEV.NRCUPOMFIS ||
                                  ' (Marca: ' || SUBSTR(C_GERANFDEV.DSMARCAECFVE, 1, 15) ||
                                  ', Mod: ' || SUBSTR(C_GERANFDEV.DSMODELOECFVE, 1, 15) ||
                                  ', N: ' || C_GERANFDEV.NRSERIEIMPVND ||
                                  ')';

                  V_NRDADOADIC := LPAD(TO_CHAR(TO_NUMBER(NVL(V_NRDADOADIC, '0')) + 1),3,'0');

                  INSERT INTO DADOSADIC
                     (CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                  VALUES
                     (P_CDFILIPROC, P_NRLANCTONF, V_NRDADOADIC, V_DSDADOADIC);

--               END IF;
            ELSE
--               IF V_IDTIPORECE IS NULL THEN
                  V_DSDADOADIC := V_DSDADOADIC || ', '|| C_GERANFDEV.NRCUPOMFIS;

                  UPDATE DADOSADIC
                  SET DSDADOADIC = V_DSDADOADIC
                  WHERE CDFILIAL   = P_CDFILIPROC AND
                        NRLANCTONF = P_NRLANCTONF AND
                        NRDADOADIC = V_NRDADOADIC;
--               END IF;
            END IF;
         END IF;

         V_NRCUPOMFIS := NVL(C_GERANFDEV.NRCUPOMFIS, 'X');
      END IF;
   END LOOP;

   SELECT MAX(C.DSMENSCPFCUP)
   INTO V_DSMENSCPFCUP
   FROM CAIXA C
   WHERE C.CDFILIAL = P_CDFILIAL AND
         C.CDCAIXA = (SELECT MIN(CDCAIXA)
                      FROM CAIXA
                      WHERE CDFILIAL = P_CDFILIAL AND
                            ((INSTR(P_CDCAIXA, CDCAIXA) > 0)  OR (P_CDCAIXA IS NULL)) AND
                            DSMENSCPFCUP IS NOT NULL);

    SELECT MAX(DSDADOADIC)
    INTO V_DSMENSDADOADIC
    FROM DADOSADIC
    WHERE CDFILIAL   = P_CDFILIPROC AND
          NRLANCTONF = P_NRLANCTONF AND
          DSDADOADIC = V_DSMENSCPFCUP;

   IF (V_DSMENSDADOADIC IS NULL) AND (V_DSMENSCPFCUP IS NOT NULL) THEN

      SELECT NVL(MAX(NRDADOADIC), '0')
      INTO V_NRDADOADIC
      FROM DADOSADIC
      WHERE CDFILIAL   = P_CDFILIPROC AND
            NRLANCTONF = P_NRLANCTONF;

      V_NRDADOADIC := LPAD(TO_CHAR(TO_NUMBER(NVL(V_NRDADOADIC, '0')) + 1),3,'0');
      IF V_NRDADOADIC < '998' THEN
         INSERT INTO DADOSADIC
            (CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
         VALUES
            (P_CDFILIPROC, P_NRLANCTONF, V_NRDADOADIC, V_DSMENSCPFCUP);
      END IF;
   END IF;


END;
/


-- VERSAO --
BEGIN ATUVEROBJ('UPDATE_ITEM_VENDA','5.50.xxx'); END;
/

